import { IgcSpreadsheetModule } from "igniteui-webcomponents-spreadsheet";
import { SpreadsheetChartAdapterLocaleEn } from './SpreadsheetChartAdapterLocaleEn';
import { Localization } from "igniteui-webcomponents-core";
import { IgcDataChartCoreModule } from "igniteui-webcomponents-charts";
import { IgcPieChartModule } from "igniteui-webcomponents-charts";
import { IgcLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcColumnSeriesModule } from "igniteui-webcomponents-charts";
import { IgcBarSeriesModule } from "igniteui-webcomponents-charts";
import { IgcSplineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcSplineAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStepLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStepAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPointSeriesModule } from "igniteui-webcomponents-charts";
import { IgcWaterfallSeriesModule } from "igniteui-webcomponents-charts";
import { IgcCrosshairLayerModule } from "igniteui-webcomponents-charts";
import { IgcCalloutLayerModule } from "igniteui-webcomponents-charts";
import { IgcItemToolTipLayerModule } from "igniteui-webcomponents-charts";
import { IgcCategoryToolTipLayerModule } from "igniteui-webcomponents-charts";
import { IgcCategoryHighlightLayerModule } from "igniteui-webcomponents-charts";
import { IgcCategoryItemHighlightLayerModule } from "igniteui-webcomponents-charts";
import { IgcFinalValueLayerModule } from "igniteui-webcomponents-charts";
import { IgcNumberAbbreviatorModule } from "igniteui-webcomponents-charts";
import { IgcDataChartInteractivityModule } from "igniteui-webcomponents-charts";
import { IgcDataChartCategoryTrendLineModule } from "igniteui-webcomponents-charts";
import { IgcDataChartAnnotationModule } from "igniteui-webcomponents-charts";
import { IgcDoughnutChartModule } from "igniteui-webcomponents-charts";
import { IgcCategoryXAxisModule } from "igniteui-webcomponents-charts";
import { IgcNumericYAxisModule } from "igniteui-webcomponents-charts";
import { IgcCategoryDateTimeXAxisModule } from "igniteui-webcomponents-charts";
import { IgcTimeXAxisModule } from "igniteui-webcomponents-charts";
import { IgcOrdinalTimeXAxisModule } from "igniteui-webcomponents-charts";
import { IgcNumericRadiusAxisModule } from "igniteui-webcomponents-charts";
import { IgcNumericAngleAxisModule } from "igniteui-webcomponents-charts";
import { IgcCategoryAngleAxisModule } from "igniteui-webcomponents-charts";
import { IgcCategoryYAxisModule } from "igniteui-webcomponents-charts";
import { IgcNumericXAxisModule } from "igniteui-webcomponents-charts";
import { IgcRadialColumnSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRadialPieSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRadialLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRadialAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPolarLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPolarSplineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPolarAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPolarSplineAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPolarScatterSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRangeAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRangeColumnSeriesModule } from "igniteui-webcomponents-charts";
import { IgcPercentChangeYAxisModule } from "igniteui-webcomponents-charts";
import { IgcFinancialPriceSeriesModule } from "igniteui-webcomponents-charts";
import { IgcIndicatorsModule } from "igniteui-webcomponents-charts";
import { IgcOverlaysModule } from "igniteui-webcomponents-charts";
import { IgcZoomSliderModule } from "igniteui-webcomponents-charts";
import { IgcFinancialLegendModule } from "igniteui-webcomponents-charts";
import { IgcLegendModule } from "igniteui-webcomponents-charts";
import { IgcItemLegendModule } from "igniteui-webcomponents-charts";
import { IgcScatterSeriesModule } from "igniteui-webcomponents-charts";
import { IgcScatterLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcScatterSplineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcBubbleSeriesModule } from "igniteui-webcomponents-charts";
import { IgcRingSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStackedAreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStackedBarSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStackedColumnSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStackedLineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStacked100AreaSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStacked100BarSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStacked100ColumnSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStacked100LineSeriesModule } from "igniteui-webcomponents-charts";
import { IgcStackedFragmentSeriesModule } from "igniteui-webcomponents-charts";
import { IgcAreaFragmentModule } from "igniteui-webcomponents-charts";
import { IgcColumnFragmentModule } from "igniteui-webcomponents-charts";
import { IgcLineFragmentModule } from "igniteui-webcomponents-charts";
import { IgcSplineFragmentModule } from "igniteui-webcomponents-charts";
import { IgcSplineAreaFragmentModule } from "igniteui-webcomponents-charts";
import { IgcBarFragmentModule } from "igniteui-webcomponents-charts";
export class IgcSpreadsheetChartAdapterModule {
    static register() {
        IgcSpreadsheetModule.register();
        IgcDataChartCoreModule.register();
        IgcPieChartModule.register();
        IgcLineSeriesModule.register();
        IgcAreaSeriesModule.register();
        IgcColumnSeriesModule.register();
        IgcBarSeriesModule.register();
        IgcSplineSeriesModule.register();
        IgcSplineAreaSeriesModule.register();
        IgcStepLineSeriesModule.register();
        IgcStepAreaSeriesModule.register();
        IgcPointSeriesModule.register();
        IgcWaterfallSeriesModule.register();
        IgcCrosshairLayerModule.register();
        IgcCalloutLayerModule.register();
        IgcItemToolTipLayerModule.register();
        IgcCategoryToolTipLayerModule.register();
        IgcCategoryHighlightLayerModule.register();
        IgcCategoryItemHighlightLayerModule.register();
        IgcFinalValueLayerModule.register();
        IgcNumberAbbreviatorModule.register();
        IgcDataChartInteractivityModule.register();
        IgcDataChartCategoryTrendLineModule.register();
        IgcDataChartAnnotationModule.register();
        IgcDoughnutChartModule.register();
        IgcCategoryXAxisModule.register();
        IgcNumericYAxisModule.register();
        IgcCategoryDateTimeXAxisModule.register();
        IgcTimeXAxisModule.register();
        IgcOrdinalTimeXAxisModule.register();
        IgcNumericRadiusAxisModule.register();
        IgcNumericAngleAxisModule.register();
        IgcCategoryAngleAxisModule.register();
        IgcCategoryYAxisModule.register();
        IgcNumericXAxisModule.register();
        IgcRadialColumnSeriesModule.register();
        IgcRadialPieSeriesModule.register();
        IgcRadialLineSeriesModule.register();
        IgcRadialAreaSeriesModule.register();
        IgcPolarLineSeriesModule.register();
        IgcPolarSplineSeriesModule.register();
        IgcPolarAreaSeriesModule.register();
        IgcPolarSplineAreaSeriesModule.register();
        IgcPolarScatterSeriesModule.register();
        IgcRangeAreaSeriesModule.register();
        IgcRangeColumnSeriesModule.register();
        IgcPercentChangeYAxisModule.register();
        IgcFinancialPriceSeriesModule.register();
        IgcIndicatorsModule.register();
        IgcOverlaysModule.register();
        IgcZoomSliderModule.register();
        IgcFinancialLegendModule.register();
        IgcLegendModule.register();
        IgcItemLegendModule.register();
        IgcScatterSeriesModule.register();
        IgcScatterLineSeriesModule.register();
        IgcScatterSplineSeriesModule.register();
        IgcBubbleSeriesModule.register();
        IgcStackedAreaSeriesModule.register();
        IgcStackedBarSeriesModule.register();
        IgcStackedColumnSeriesModule.register();
        IgcStackedLineSeriesModule.register();
        IgcStacked100AreaSeriesModule.register();
        IgcStacked100BarSeriesModule.register();
        IgcStacked100ColumnSeriesModule.register();
        IgcStacked100LineSeriesModule.register();
        IgcStackedFragmentSeriesModule.register();
        IgcAreaFragmentModule.register();
        IgcRingSeriesModule.register();
        IgcColumnFragmentModule.register();
        IgcLineFragmentModule.register();
        IgcSplineFragmentModule.register();
        IgcSplineAreaFragmentModule.register();
        IgcBarFragmentModule.register();
        Localization.register("spreadsheetchartadapter", new SpreadsheetChartAdapterLocaleEn());
    }
}
//# sourceMappingURL=igc-spreadsheet-chart-adapter-module.js.map
